create or replace PROCEDURE EXPORTA_ORDEM_ENTRADA_SAGA
IS
   /* INT_ORDENTSAI */
   V_CDFILIAL        VARCHAR2(4);
   V_NRLANCTONF      VARCHAR2(10);
   V_NROORD          VARCHAR2(40);
   V_CODSTE          VARCHAR2(20);
   V_CODPSSPRP       VARCHAR2(20);
   V_CODPSSCLI       VARCHAR2(20);
   V_CODTIPORD       NUMBER;
   V_CODPSSTRP       VARCHAR2(20);
   V_CODPRIATD       NUMBER;
   V_BOLATDPRC       NUMBER;
   V_BOLCANLOT       NUMBER;
   V_BOLCANORDATDPRC NUMBER;
   V_BOLMNTPLT       NUMBER;
   V_BOLPERINSITMORD NUMBER;
   V_BOLPERPENESQ    NUMBER;
   V_BOLRECMERFORPED NUMBER;
   V_CODAGPMTG       VARCHAR2(40);
   V_CODPSSFLL       VARCHAR2(20);
   V_CODPSSFOR       VARCHAR2(20);
   V_CODPSSPNTDST    VARCHAR2(20);
   V_CODPSSTRPRDP    VARCHAR2(20);
   V_CODTIPMDLTRP    NUMBER;
   V_DATAGN          DATE;
   V_DATATD          DATE;
   V_DATGERORD       DATE;
   V_DESOBS          VARCHAR2(300);
   V_GERAUTOPE       NUMBER;
   V_NROEXT          VARCHAR2(40);
   V_NROITM          INTEGER;
   V_NROORDEXT       VARCHAR2(40);
   V_NUMAGP          VARCHAR2(40);
   V_NUMSEQCRG       INTEGER;
   V_VLRPERATNORDCMP NUMBER;
   V_FLAPRC          VARCHAR2(5);
   V_DSCERR          VARCHAR2(300);
   V_DATULTPRC       DATE;
   V_CDFILIRECE      VARCHAR2(4);
   /* INT_ORDENTSAI */
   V_CODMER          VARCHAR2(20);
   V_VALEMBSKU       NUMBER;
   V_VLRQTDMER       NUMBER;
   V_NROITMORD       NUMBER;
   V_BOLDATLIMFLX    NUMBER;
   V_BOLMERAUD       NUMBER;
   V_BOLMERCMP       NUMBER;
   V_BOLREFDATFAB    NUMBER;
   V_BOLREQCAROPC    NUMBER;
   V_BOLTRCEMB       NUMBER;
   V_CODDSP          VARCHAR2(20);
   V_CODGRPTOL       VARCHAR2(20);
   V_CODMTVBLQ       NUMBER;
   V_CODSTSESQ       VARCHAR2(20);
   V_CODTIPRCB       NUMBER;
   V_DATFABPRG       DATE;
   V_DATFIMPRG       DATE;
   V_DATLIMFAB       DATE;
   V_DATLIMINF       DATE;
   V_DATVNCPRG       DATE;
   V_NRODOCEXT       VARCHAR2(40);
   V_NROITMORDEXT    VARCHAR2(40);
   V_NROITMPAI       NUMBER;
   V_VALMERDOC       NUMBER;
   V_VLRQTDPCS       NUMBER;
   V_OBSFISCAL       VARCHAR2(200);
   V_CDPRODUTO       VARCHAR2(10);
   V_VRFATOCONV      NUMBER;
   /* CARACPRODSAGA */
   V_VRFATORSKU      NUMBER;
   /* CONTROLE */
   V_CONTROLE        VARCHAR2(40);
   V_BOOLPRODUTO     BOOLEAN;
   V_FILIAL          VARCHAR2(4);
   V_LANCTONF        VARCHAR2(10);
   V_BOLNOVOREG      BOOLEAN;
   V_CDPRODCARAC     VARCHAR2(10);
   V_ORDEMINVALIDA   VARCHAR2(40);
   V_NMPRODUTO       VARCHAR2(80);
   V_BOLMERMNS       VARCHAR2(1);
   V_CDPRODNIVANTE   VARCHAR2(20);
   V_ERRO            VARCHAR2(300);
   V_IDPRODMENSU     VARCHAR2(1);
   
   /* P_FILIALSAGA||N.CDFILIAL||N.NRLANCTONF NRORD -> FOI ALTERADO PARA NAO AFETAR AS ROTINAS DA RISOTOLANDIA */
   CURSOR C_ORDENTSAI(P_FILIALSAGA IN VARCHAR2) IS
      SELECT N.CDFILIAL, N.NRLANCTONF, '1'||N.CDFILIAL||N.NRLANCTONF NRORD, NVL(N.NRINSJURNF, REGEXP_REPLACE(N.CDFORNECED, '\D')) CODPSSCLI,
             N.CDFILIRECE
        FROM NOTAFISCAL N, PARAMFILIAL P
       WHERE P.CDFILIAL = N.CDFILIRECE
         AND N.IDENTRSAIDOP = 'E'
         AND N.DTEXPNFSAGA IS NULL
         AND NVL(N.IDSISTEMA, 'DFE') = 'DFE'
         AND P.CDFILIALSAGA IS NOT NULL
         --AND  N.NRLANCTONF = '0000880899'
         AND N.DTENTRSAID >= '08/12/2016'
         AND EXISTS(SELECT CDFILIAL, NRLANCTONF
                      FROM ITEMPRODUTO I
                     WHERE I.CDFILIAL   = N.CDFILIAL
                       AND I.NRLANCTONF = I.NRLANCTONF);
   
   CURSOR C_INT_ITMORDENTSAI(P_CDFILIAL IN VARCHAR2, P_NRLANCTONF IN VARCHAR2, P_CDFILIRECE IN VARCHAR2) IS
      SELECT I.QTITEMPROD, TO_NUMBER(I.NRSEQITPROD) NROITMORD, P.CDPRODESTO, P.VRFATOCONV, C.CDPRODUTO, NVL(C.IDPRODMENSU, 'N') BOLMERMNS, P.CDPRODNIVANTE,
             B.CDARVPROD, P.NMPRODUTO
        FROM ITEMPRODUTO I, PRODUTO P, CARACPRODSAGA C, PRODFILI PF, PRODUTO B
       WHERE I.CDFILIAL   = P_CDFILIAL
         AND I.NRLANCTONF = P_NRLANCTONF
         AND PF.CDFILIAL  = P_CDFILIRECE
         AND I.CDPRODUTO  = P.CDPRODUTO
         AND P.CDPRODUTO  = C.CDPRODUTO(+)
         AND PF.CDPRODUTO = P.CDPRODUTO
         AND P.CDPRODESTO = B.CDPRODUTO
         AND NVL(PF.IDCNTRESTOQ, 'S') <> 'N';
   
BEGIN
   V_CODPSSPRP       := '1';
   V_CODTIPORD       := 1;
   V_CODPRIATD       := 50;
   V_BOLATDPRC       := 1;
   V_BOLCANLOT       := 0;
   V_BOLCANORDATDPRC := 0;
   V_BOLMNTPLT       := 1;
   V_BOLPERINSITMORD := 1;
   V_BOLPERPENESQ    := 0;
   V_BOLRECMERFORPED := 0;
   V_CODAGPMTG       := NULL;
   V_CODPSSFLL       := NULL;
   V_CODPSSFOR       := NULL;
   V_CODPSSPNTDST    := NULL;
   V_CODPSSTRPRDP    := NULL;
   V_CODTIPMDLTRP    := NULL;
   V_DATAGN          := NULL;
   V_DATATD          := NULL;
   V_DESOBS          := NULL;
   V_GERAUTOPE       := 0;
   V_NROEXT          := NULL;
   V_NROORDEXT       := NULL;
   V_NUMSEQCRG       := 0;
   V_VLRPERATNORDCMP := 0;
   V_FLAPRC          := '0';
   V_DSCERR          := NULL;
   V_VALEMBSKU       := 1;
   V_BOLDATLIMFLX    := 1;
   V_BOLMERAUD       := 0;
   V_BOLMERCMP       := 0;
   V_BOLREFDATFAB    := 1;
   V_BOLREQCAROPC    := 1;
   V_BOLTRCEMB       := 1;
   V_CODDSP          := NULL;
   V_CODGRPTOL       := NULL;
   V_CODMTVBLQ       := NULL;
   V_CODSTSESQ       := NULL;
   V_CODTIPRCB       := 1;
   V_DATFABPRG       := NULL;
   V_DATFIMPRG       := NULL;
   V_DATLIMFAB       := NULL;
   V_DATLIMINF       := NULL;
   V_DATVNCPRG       := NULL;
   V_NRODOCEXT       := NULL;
   V_NROITMORDEXT    := NULL;
   V_NROITMPAI       := NULL;
   V_VALMERDOC       := NULL;
   V_VLRQTDPCS       := NULL;
   V_OBSFISCAL       := NULL;
   V_CONTROLE        := ' ';
   V_ORDEMINVALIDA   := NULL;
   
   SELECT MAX(CDFILIALSAGA)
     INTO V_CODSTE
     FROM PARAMFILIAL;
   
   IF (V_CODSTE IS NOT NULL) THEN
      OPEN C_ORDENTSAI(V_CODSTE);
      LOOP
         FETCH C_ORDENTSAI INTO V_CDFILIAL, V_NRLANCTONF, V_NROORD, V_CODPSSCLI, V_CDFILIRECE;
         IF ((V_CONTROLE <> V_NROORD) OR (C_ORDENTSAI%NOTFOUND)) THEN
            IF (V_BOOLPRODUTO) THEN
               DELETE FROM INT_ORDENTSAI
                WHERE NROORD = V_NROORD
                  AND FLAPRC = '2';
            
               DELETE FROM INT_ITMORDENTSAI
                WHERE NROORD = V_NROORD
                  AND FLAPRC = '2';

               UPDATE NOTAFISCAL
                  SET DTEXPNFSAGA = SYSDATE,
                      IDBLOQUEADO = 'S'
                WHERE CDFILIAL    = V_FILIAL
                  AND NRLANCTONF  = V_LANCTONF;
               
               UPDATE INT_ORDENTSAI
                  SET NROITM = V_NROITM
                WHERE NROORD = V_CONTROLE;
            ELSE
               IF (V_ORDEMINVALIDA IS NOT NULL) THEN
                  UPDATE NOTAFISCAL
                     SET DTEXPNFSAGA = SYSDATE,
                         IDBLOQUEADO = 'S'
                   WHERE CDFILIAL    = V_FILIAL
                     AND NRLANCTONF  = V_LANCTONF;
                     
                  UPDATE INT_ITMORDENTSAI
                     SET FLAPRC = '2',
                         DSCERR = 'A nota possui outro item sem caracterstica informada'
                   WHERE NROORD = V_ORDEMINVALIDA
                     AND FLAPRC <> '2';
                  
                  UPDATE INT_ORDENTSAI
                     SET FLAPRC = '2',
                         DSCERR = 'Produto(s) lanado(s) na nota no tem caracterstica cadastrada',
                         NROITM = V_NROITM
                   WHERE NROORD = V_ORDEMINVALIDA;
               END IF;
            END IF;
            
            V_BOOLPRODUTO   := TRUE;
            V_BOLNOVOREG    := TRUE;
            V_ORDEMINVALIDA := '';
            V_DATULTPRC     := SYSDATE;
                        
            COMMIT;
         END IF;
         EXIT WHEN C_ORDENTSAI%NOTFOUND;
         
         --V_CONTROLE    := ' ';
         V_NROITM := 0;
         OPEN C_INT_ITMORDENTSAI(V_CDFILIAL, V_NRLANCTONF, V_CDFILIRECE);
         LOOP
            FETCH C_INT_ITMORDENTSAI INTO V_VLRQTDMER, V_NROITMORD, V_CDPRODUTO, V_VRFATOCONV, V_CDPRODCARAC, V_BOLMERMNS, V_CDPRODNIVANTE,
                                          V_CODMER, V_NMPRODUTO;
            EXIT WHEN C_INT_ITMORDENTSAI%NOTFOUND;
            
            IF V_BOLNOVOREG THEN
               V_CONTROLE  := V_NROORD;
               V_CODPSSTRP := V_CODPSSCLI;
               V_FILIAL    := V_CDFILIAL;
               V_LANCTONF  := V_NRLANCTONF;
               
               INSERT INTO INT_ORDENTSAI(NROORD, CODSTE, CODPSSPRP, CODPSSCLI, CODTIPORD, CODPSSTRP, CODPRIATD, BOLATDPRC, BOLCANLOT, BOLCANORDATDPRC, 
                                         BOLMNTPLT, BOLPERINSITMORD, BOLPERPENESQ, BOLRECMERFORPED, CODAGPMTG, CODPSSFLL, CODPSSFOR, CODPSSPNTDST, 
                                         CODPSSTRPRDP, CODTIPMDLTRP, DATAGN, DATATD, DATGERORD, DESOBS, GERAUTOPE, NROEXT, /*NROITM,*/ NROORDEXT, NUMAGP,
                                         NUMSEQCRG, VLRPERATNORDCMP, FLAPRC, DSCERR, DATULTPRC)
               VALUES(V_NROORD, V_CODSTE, V_CODPSSPRP, V_CODPSSCLI, V_CODTIPORD, V_CODPSSTRP, V_CODPRIATD, V_BOLATDPRC, V_BOLCANLOT, V_BOLCANORDATDPRC, 
                      V_BOLMNTPLT, V_BOLPERINSITMORD, V_BOLPERPENESQ, V_BOLRECMERFORPED, V_CODAGPMTG, V_CODPSSFLL, V_CODPSSFOR, V_CODPSSPNTDST, 
                      V_CODPSSTRPRDP, V_CODTIPMDLTRP, V_DATAGN, V_DATATD, V_DATGERORD, V_DESOBS, V_GERAUTOPE, V_NROEXT, /*V_NROITM,*/ V_NROORDEXT, V_NUMAGP,
                      V_NUMSEQCRG, V_VLRPERATNORDCMP, V_FLAPRC, V_DSCERR, V_DATULTPRC);
               
               V_BOLNOVOREG := FALSE;
            END IF;
            
            V_ERRO   := NULL;
            V_NROITM := V_NROITM + 1;
            
            IF (V_CDPRODCARAC IS NOT NULL) THEN
               BEGIN
                  SELECT P.VRFATOCONV, NVL(C.IDPRODMENSU, 'N') IDPRODMENSU
                    INTO V_VRFATORSKU, V_IDPRODMENSU
                    FROM PRODUTO P, CARACPRODSAGA C
                   WHERE P.CDPRODESTO = V_CDPRODUTO
                     AND P.CDPRODUTO  = C.CDPRODUTO
                     AND C.IDUNIDPADRSAGA = 'S';
               EXCEPTION
                  WHEN OTHERS THEN
                     V_VRFATORSKU := 0;
                     V_ERRO := 'Produto '||V_CODMER||' - '||V_NMPRODUTO||' no possui unidade de medida padro para rvore que pertence.';
                     V_VLRQTDMER := 0;
                     V_FLAPRC := '2';
               END;
               
               IF (V_IDPRODMENSU = 'N') THEN
                  IF (V_VRFATORSKU > 0) THEN
                     V_VLRQTDMER := CEIL((V_VLRQTDMER*V_VRFATOCONV)/V_VRFATORSKU); /* *V_VRFATOCONV; */
                  ELSE
                     V_ERRO := 'Produto '||V_CODMER||' - '||V_NMPRODUTO||' possui fator de converso igual a 0.';
                     V_FLAPRC := '2';
                  END IF;
               ELSE
                  V_VLRQTDMER := V_VLRQTDMER;
               END IF;
            ELSE
               V_ERRO := 'Produto '||V_CODMER||' - '||V_NMPRODUTO||' no possui caractersticas cadastradas no sistema.';
               V_FLAPRC := '2';
            END IF;

            INSERT INTO INT_ITMORDENTSAI(NROORD, CODSTE, CODPSSPRP, CODMER, VALEMBSKU, VLRQTDMER, NROITMORD, CODTIPORD, BOLDATLIMFLX, BOLMERAUD, BOLMERCMP,
                                         BOLREFDATFAB, BOLREQCAROPC, BOLTRCEMB, CODDSP, CODGRPTOL, CODMTVBLQ, CODSTSESQ, CODTIPRCB, DATFABPRG, DATFIMPRG,
                                         DATLIMFAB, DATLIMINF, DATVNCPRG, NRODOCEXT, NROITMORDEXT, NROITMPAI, NROORDEXT, VALMERDOC, VLRQTDPCS, OBSFISCAL, 
                                         FLAPRC, DSCERR, DATULTPRC)
            VALUES(V_NROORD, V_CODSTE, V_CODPSSPRP, V_CODMER, V_VALEMBSKU, V_VLRQTDMER, V_NROITMORD, V_CODTIPORD, V_BOLDATLIMFLX, V_BOLMERAUD, V_BOLMERCMP,
                   V_BOLREFDATFAB, V_BOLREQCAROPC, V_BOLTRCEMB, V_CODDSP, V_CODGRPTOL, V_CODMTVBLQ, V_CODSTSESQ, V_CODTIPRCB, V_DATFABPRG, V_DATFIMPRG,
                   V_DATLIMFAB, V_DATLIMINF, V_DATVNCPRG, V_NRODOCEXT, V_NROITMORDEXT, V_NROITMPAI, V_NROORDEXT, V_VALMERDOC, V_VLRQTDPCS, V_OBSFISCAL, 
                   V_FLAPRC, V_DSCERR, V_DATULTPRC);
            
            IF (V_ERRO IS NOT NULL) THEN
               V_BOOLPRODUTO := FALSE;
               V_ORDEMINVALIDA := V_NROORD;
               UPDATE INT_ITMORDENTSAI
                  SET FLAPRC = '2',
                      DSCERR = V_ERRO
                WHERE NROORD = V_NROORD
                  AND CODMER = V_CODMER;
            END IF;
         END LOOP;
         
         /*IF NOT(V_BOOLPRODUTO) THEN
            DELETE FROM INT_ORDENTSAI
             WHERE NROORD = V_NROORD;
            
            DELETE FROM INT_ITMORDENTSAI
             WHERE NROORD = V_NROORD;
         ELSE
            IF (TRIM(V_CONTROLE) IS NOT NULL) THEN
               UPDATE NOTAFISCAL
                  SET DTEXPNFSAGA = SYSDATE,
                      IDBLOQUEADO = 'S'
                WHERE CDFILIAL    = V_CDFILIAL
                  AND NRLANCTONF  = V_NRLANCTONF;
            END IF;
         END IF;
         */
            
            --IF (V_VRFATORSKU IS NOT NULL) THEN
            /*V_VRFATORSKU := 0;
            IF (V_BOLMERMNS = 'N') THEN
               IF (V_CDPRODCARAC <> V_CDPRODUTO) THEN
                  FOR C_PRODUTO IN (SELECT P.CDPRODUTO, P.VRFATOCONV
                                      FROM PRODUTO P, CARACPRODSAGA C
                                     WHERE INSTR(P.CDARVPROD, V_CDPRODNIVANTE) > 0
                                       AND VRFATOCONV IS NOT NULL
                                       AND P.CDPRODUTO = C.CDPRODUTO
                                     ORDER BY CDARVPROD)
                  LOOP
                     IF (V_VRFATORSKU < C_PRODUTO.VRFATOCONV) THEN
                        V_VRFATORSKU := C_PRODUTO.VRFATOCONV;
                        V_CDPRODUTO  := C_PRODUTO.CDPRODUTO;
                     END IF;
                  END LOOP;
                  IF (V_VRFATORSKU > 0) THEN
                     V_VRFATOCONV := V_VRFATORSKU;
                  END IF;                  
                  --V_VRFATOCONV := V_VRFATORSKU;
               END IF;
            END IF;*/
         CLOSE C_INT_ITMORDENTSAI;
      END LOOP;
      
      COMMIT;
      CLOSE C_ORDENTSAI;
   END IF;
EXCEPTION
   WHEN OTHERS THEN
      --ROLLBACK;
      
      V_ERRO := SQLERRM(SQLCODE);
      
      UPDATE INT_ORDENTSAI
        SET FLAPRC = '2',
            DSCERR = V_ERRO
      WHERE NROORD = V_NROORD;
      
      UPDATE INT_ITMORDENTSAI
         SET FLAPRC = '2',
             DSCERR = 'Ocorreu um erro durante a exportao'
       WHERE NROORD = V_NROORD;
      
      COMMIT;
      IF C_INT_ITMORDENTSAI%ISOPEN THEN
         CLOSE C_INT_ITMORDENTSAI;
      END IF;
      
      CLOSE C_ORDENTSAI;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_ORDEM_ENTRADA_SAGA','5.45.XXX'); END;
/